; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; //---                 Damol Software                      ---\\ ;
; \\-----------------------------------------------------------// ;
; //---                   DolPass.asm                       ---\\ ;
; \\---                                                     ---// ;
; //---            A password program for ti89              ---\\ ;
; \\---                                                     ---// ;
; //-----------------------------------------------------------\\ ;
; \\--- Written by maDLess maDLess@damol.8m.com             ---// ;
; //---        and Olivlalo Olivlalo@damol.8m.com           ---\\ ;
; \\-----------------------------------------------------------// ;
; //--- the Damol Software Web Site :                       ---\\ ;
; \\---            http://damol.8m.com/                     ---// ;
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;


 include "tios.h"
 include "util.h"

 xdef _main
 xdef _ti89

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // void Put_str ( char *String, int x, int y, int color );
; // Famous one
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

Put_str MACRO
 move.w   \4,-(a7)
 pea      \1
 move.w   \3,-(a7)
 move.w   \2,-(a7)
 jsr      tios::DrawStrXY
 adda.l   #10,a7
 ENDM

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // void Get_str ( char *String, int x, int y, int num_char );
; // Quite spread one too
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

Get_str MACRO
        move.w \2,d5
        move.w \3,d6
        move.w \4-1,d7
        move.w d7,d4
        move.l #\1,a5
        bsr take_string
        ENDM

_main:

first
 jsr      util::zap_screen
 Put_str  menu,#10,#20,#4
 Put_str  shutdown,#10,#35,#4   
 Put_str  changepwd,#10,#50,#4
 Put_str  exit,#10,#65,#4 

debut
 jsr      util::idle_loop
 cmp.w    #49,d0                ; "1" or "q" (if alpha is pressed) selected so jump to shutdown
 beq      shut
 cmp.w    #113,d0
 beq      shut
 cmp.w    #51,d0                ; "3" or "s" (if alpha is pressed) pressed -> exit
 beq      bye
 cmp.w    #115,d0
 beq      bye
 cmp.w    #50,d0                ; "2" or "r" (if alpha is pressed) pressed -> change
 beq      change
 cmp.w    #114,d0
 beq      change 
 bra      debut                 ; other key pressed scan the keyboard again
      
shut
 jsr      util::zap_screen
 trap     #4                    ; shut down the calc
 Put_str  prompt,#10,#40,#4 
 Get_str  string,#72,#40,#10 
 pea      sto_pass              ; compare 'string' what u've entered with 'sto_pass' the real password
 pea      string
 jsr      tios::strcmp
 adda.l   #8,a7
 cmp.w    #0,d0                 ; if 'string'='sto_pass' -> exit
 beq      bye
 bra      shut                  ; else shut the calc down

bye
 rts

change
 jsr      util::zap_screen
 Put_str  oldpass,#10,#40,#4    ; ask for the old pwd
 Get_str  string,#72,#40,#10 
 pea      sto_pass              ; compare 'string'=what u've entered with 'sto_pass'=the real password
 pea      string
 jsr      tios::strcmp
 adda.l   #8,a7
 cmp.w    #0,d0                 ; if 'string'='sto_pass' -> go to the new pass prompt
 beq      enter_new_pass
 bra      shut                  ; else : someone may try to change your pass word !!!
                                ; turn off the calc ... so he has to know the real 
                                ; password
enter_new_pass
 jsr      util::zap_screen
 Put_str  newpass,#10,#40,#4    ; ask for the new pwd
 Get_str  string,#72,#40,#10    ; put it in string
 Put_str  confirm,#10,#55,#4    ; reask the new password 
 Get_str  string2,#72,#55,#10   ; put it in string2
 pea      string                ; 
 pea      string2               ; 
 jsr      tios::strcmp          ; compare string and string2
 adda.l   #8,a7                 ; restore the stack
 cmp.w    #0,d0                 ; if 'string'='string2'
 beq      change_it             ; goto change_it
 jsr      util::zap_screen      ; else 
 Put_str  notchanged,#10,#40,#4 ; the password is NOT changed                   
 jsr      util::idle_loop       ; wait for a key press
 bra      first
change_it
 move.l   #10,-(a7)             ; copy the 10 first char
 pea      string                ; from string
 pea      sto_pass              ; to sto_pass
 jsr      tios::strncpy
 adda.l   #12,a7
 jsr      util::zap_screen      ;  
 Put_str  changed,#7,#40,#4     ; the password is changed    
 jsr      util::idle_loop       ; wait for a key press       
 bra      first

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // second part of the Get_str routine
; // ThanX to Alban Gervaise
; //  params : see the Get_str macro
; //  registers : d0,d4,d5,d6,d7 / a5,(a7) are lost
; // 
; // if try is set to 0 before u call the routine -> * instead of
; // real characters
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

take_string:
 jsr      util::idle_loop
 cmp.w    #257,d0
 beq      undo
 cmp.w    #264,d0
 beq      bon
 cmp.w    #13,d0
 beq      bon
 move.b   d0,(a5)+
 move.w   #2,-(a7)
 move.w   d6,-(a7)
 move.w   d5,-(a7)

 cmp.b    #0,try                    ; if try is set to 0 
 beq      stars                     ; put stars
 move.w   d0,-(a7)                  ; else normal character
 bra      end_stars

stars
 move.w   #42,-(a7) 
end_stars
  
 jsr      util::DrawCharXY
 lea      8(a7),a7
 add.w    #6,d5
 dbra     d7,take_string
bon
 cmp.w    d4,d7
 beq      take_string
 clr.b    (a5)
 rts
undo
 cmp.w    d4,d7
 beq      take_string
 add.w    #1,d7
 clr.b    -(a5)
 sub.w    #6,d5
 move.w   #4,-(a7)
 move.w   d6,-(a7)
 move.w   d5,-(a7)
 move.w   #32,-(a7)
 jsr      util::DrawCharXY
 lea      8(a7),a7
 bra      take_string

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // The Data section
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;


prompt        dc.b "PassWord :",0
sto_pass      dc.b "damol",0,0,0,0,0,0        ; 10 char max string for the password
string        dc.b "          ",0             ; for the input
string2       dc.b "          ",0             ; to confirm the new password 
try           dc.b 0                          ; * or not ?
menu          dc.b "Menu",0
changepwd     dc.b "2. Change the password",0
shutdown      dc.b "1. Turn off the calc",0
exit          dc.b "3. Exit",0
oldpass       dc.b " Old Pwd :",0
newpass       dc.b " New Pwd :",0
confirm       dc.b " Confirm :",0
notchanged    dc.b "PassWord NOT changed !!",0
changed       dc.b "Pwd changed successfully",0

 end
